using System;
using System.Collections.Generic;
using System.Text;
using Syncfusion.Windows.Forms.Grid;

namespace POC
{
    public interface IVirtualGridDataProvider
    {
        void QueryRowCount(GridRowColCountEventArgs e);
        void QueryColCount(GridRowColCountEventArgs e);
        void QueryCellInfo(GridQueryCellInfoEventArgs e);
        void QueryRowHeight(GridRowColSizeEventArgs e);
        void QueryColWidth(GridRowColSizeEventArgs e);
        void QueryCoveredRange(GridQueryCoveredRangeEventArgs e);

        event EventHandler ResetVolatileData;
    }

    public abstract class Styler
    {
        protected GridModel _gridData = null;
        public GridModel GridData 
        {
            set
            {
                _gridData = value;
            }
        }

        protected GridModel Data
        {
            get
            {
                return _gridData;
            }
        }

        public abstract void SetInfo(int rowIndex, int colIndex, Syncfusion.Windows.Forms.Grid.GridStyleInfo info);
    }
}
