using System;
using System.Collections.Generic;
using System.Text;
using System.ComponentModel;

namespace POC
{
    public class ListDataProvider<T> : IVirtualGridDataProvider
    {
        IList<T> _dataList = null;

        PropertyDescriptorCollection _propertyDescriptors;
        public ListDataProvider()
        {
            //_dataList = dataList;
            _propertyDescriptors = TypeDescriptor.GetProperties(typeof(T), new Attribute[] { new BindableAttribute(true) });
        }

        public IList<T> DataList
        {
            get { return _dataList; }
            set
            {
                _dataList = value;
                if (ResetVolatileData != null)
                    ResetVolatileData(this,EventArgs.Empty);
            }
        }
        #region IVirtualGridDataProvider Members

        public void QueryRowCount(Syncfusion.Windows.Forms.Grid.GridRowColCountEventArgs e)
        {
            e.Count = (_dataList != null ? _dataList.Count : 0);
            e.Handled = true;
        }

        public void QueryColCount(Syncfusion.Windows.Forms.Grid.GridRowColCountEventArgs e)
        {
            e.Count = _propertyDescriptors.Count;
            e.Handled = true;
        }

        public void QueryCellInfo(Syncfusion.Windows.Forms.Grid.GridQueryCellInfoEventArgs e)
        {
            if (_dataList != null)
            {
                if (e.RowIndex == 0)
                {
                    if (e.ColIndex > 0 )//&& e.ColIndex <= _propertyDescriptors.Count)
                    {
                        e.Style.CellValue = (_propertyDescriptors[e.ColIndex - 1].Attributes[typeof(DisplayNameAttribute)] as DisplayNameAttribute).DisplayName;
                        e.Style.CellValueType = _propertyDescriptors[e.ColIndex - 1].PropertyType;
                        e.Handled = true;
                    }
                }
                if (e.ColIndex > 0 && e.RowIndex > 0)
                {
                    e.Style.CellValue = _propertyDescriptors[e.ColIndex - 1].GetValue(_dataList[e.RowIndex - 1]);
                    e.Handled = true;
                }
            }
        }

        public void QueryRowHeight(Syncfusion.Windows.Forms.Grid.GridRowColSizeEventArgs e)
        {
            
        }

        public void QueryColWidth(Syncfusion.Windows.Forms.Grid.GridRowColSizeEventArgs e)
        {
            
        }

        public void QueryCoveredRange(Syncfusion.Windows.Forms.Grid.GridQueryCoveredRangeEventArgs e)
        {
        }

        public void Refresh()
        {
            if (ResetVolatileData != null)
                ResetVolatileData(this, EventArgs.Empty);
        }

        public event EventHandler ResetVolatileData;

        #endregion
    }
}
